import time
import RPi.GPIO as GPIO


#Params
FREQUENCY = 50  #Control frequency: 50 Hz == 20 ms
DUTY_MIN = 5 # 20ms/1ms
DUTY_MAX = 10 #20ms/2ms
DUTY_INC = 0.05



#Defining numbering system used by PI
GPIO.setmode(GPIO.BOARD)  #We use physical pin num
configuration = GPIO.getmode()
if(configuration == 10):
    print("PI is using the numerotation: BOARD")
    control_pin = 12
    print("Control signal will be generated on pin {}".format(control_pin))

elif(configuration == 11):
    print("PI is using the numerotation: BCM")
    control_pin = 18
    print("Control signal will be generated on pin {}".format(control_pin))

else:
    print("Error: unknown numerotation used")
    exit(1)

#I/O initialization
GPIO.setup(control_pin, GPIO.OUT, initial=GPIO.LOW)  #output pin, starting with low
control_initial_value = GPIO.input(control_pin)
print("Control signal initialised at value {}".format(control_initial_value))

#Create PWM object
pwm = GPIO.PWM(control_pin, FREQUENCY)



#Calibration
pwm.start(0)
print("Disconnect ESC power then press enter\n")
inp = input()
if inp == '':
    pwm.start(DUTY_MAX)
    print("PWM signal, duty = {}, frequency = {}\n".format(DUTY_MAX, FREQUENCY))
    print("Connect battery, wait 2 beeps and press Enter\n")
    inp = input()
    if inp == '':
        pwm.start(DUTY_MIN)
        print("PWM signal, duty = {}, frequency = {}\n".format(DUTY_MIN, FREQUENCY))
        print("Press Enter when all beeps finished\n")





pwm.stop()
print("PWM signal stopped")
time.sleep(2)


current_duty = DUTY_MIN

try:
    while(True):
        print("PWM signal, duty = {}, frequency = {}".format(current_duty, FREQ$
        pwm.start(current_duty)
        time.sleep(0.5)
        current_duty += DUTY_INC

except KeyboardInterrupt:
    print("PWM signal stopped")
    pwm.stop()


#Safely exit program
GPIO.cleanup()
print("Cleanup")

87978 00000 n
0084488379 00000 n
0084488783 00000 n
0084489172 00000 n
0084489560 00000 n
00844899